/*  fixlist.c - file to translate a WC Pro 2-line file listing into a form */
/*  that can be used by WCFILE to add files to the WC 3.01S database.      */
/*  I used it successfully here with WC 3.01, but I will not be held       */
/*  responsible for any results of the use of this program.  I hope that   */
/*  you find it useful.  Mike Willour September 29, 1993                   */
/*                                                                         */
/*  Oh, the syntax for using the program is simply "Fixlist <Filename>     */
/*  The output file has the same name as the original, so if you only have */
/*  one copy of your list back it up before running this program.          */


#include <stdio.h>
#include <io.h>

char c=0, d=0;
int count;
FILE *infile, *tempfile;

void main(int argc, char *argv[])
{


   infile=fopen(argv[1],"r");
   if(infile==NULL)                /* Check to see if file exists           */
   {
   puts("Error Opening File");
   exit(1);                        /* If file not found - Exit              */
   }


tempfile = tmpfile();                      /* Open work file, which will be */
                                           /* automatically erased                  */
while(1)
{
	c=fgetc(infile);
	if(feof(infile)!=0) break;
	switch(c)
	{
        case 42:                           /* Handles the area headers*/
				do
				{
                c=fgetc(infile);
				}
				while(c!=10);
				c=fgetc(infile);
				break;

        default:                          /* This whole case reads in one */
                d=0;                      /* file description */
				do
				{
				fputc(c,tempfile);
				c=fgetc(infile);
				d++;
				}
				while(c!=32);

				if(d<12)
				{
				do
				{
				fputc(32,tempfile);
				d++;
				}
				while(d<12);
				}

				do
				{
				c=fgetc(infile);
				}
				while(c!=124);
				c=fgetc(infile);

				do
				{
				c=fgetc(infile);
				if(c!=10 && c!=13) fputc(c,tempfile);
				}
				while(c!=10);

				do
				{
				c=fgetc(infile);
				}
				while(c!=124);

				do
				{
				c=fgetc(infile);
				if(c!=13 && c!=10) fputc(c,tempfile);
				}
				while(c!=10);
				c=fgetc(infile);
				fputc(10,tempfile);
				break;
	}
}

COPYBACK:
c=0;                               /* Reset c.                              */
rewind(tempfile);                  /* Jump to top of tempfile               */
fclose(infile);
infile=fopen(argv[1], "w");        /* Set file to write mode.               */
	while(1)
	{
	c=fgetc(tempfile);              /* Copy file back to original name.      */
	if(feof(tempfile)!=0)break;     /* Stop when you get to the end of file  */
	fputc(c, infile);
	}
fclose(infile);                    /* Close original file                   */
exit();
}
